data_dir = "{{ data_dir }}"
server = true
bind_addr = "{{ ipv4_internal }}"
datacenter = "h1"
bootstrap_expect = 3
{% if encrypt_traffic is true and consul_encrypt_key is defined %}
{%- raw -%}
{{- with secret "bootstrapper_kv/data/consul/encrypt_key" }}
encrypt = "{{ .Data.data.key }}"
{{ end -}}
{% endraw -%}
{% endif %}
retry_join = ["{% for member in consul_cluster | sort() %}{% if member != ipv4_internal %}{{ member }}{% if serf_lan_port != 8301 %}:{{ serf_lan_port }}{% endif %}{% endif %}{% if not loop.last %}", "{% endif %}{% endfor %}"]
node_name = "{{ name | default('unknown') }}-server"
ports = {
  dns = 18600,
  http = 18500,
  https = {{ https_port }},
  grpc = 18502,
{% if encrypt_traffic is defined and encrypt_traffic is true %}
  grpc_tls = {{ grpc_tls_port }},
{% endif %}
  serf_lan = {{ serf_lan_port }},
  serf_wan = 18302,
  server = {{ server_port }}
}

{% if encrypt_traffic is defined and encrypt_traffic is true %}
tls {
  defaults {
    verify_incoming = true
    verify_outgoing = true
    ca_file = "/etc/pki/ca-trust/source/anchors/hetzner_aditronic_bootstrap.pem"
    cert_file = "/etc/pki/tls/certs/hostcert.pem"
    key_file = "/etc/pki/tls/private/hostkey.pem"
  }
  internal_rpc {
    verify_server_hostname = true
  }
}

auto_encrypt {
  allow_tls = true
}

{% endif %}
{% if acl_enabled is true %}
acl {
  enabled = true,
  default_policy = "{{ acl_default_policy }}",
  enable_token_persistence = true,
  tokens {
{% raw -%}
{{- with secret "bootstrapper_kv/data/consul/initial_management_token" }}
    initial_management = "{{ .Data.data.key }}"
    agent = "{{ .Data.data.key -}}"
{{ end }}
{% endraw %}
  }
}

{% endif %}
connect {
  enabled = true
  ca_provider = "vault"
  ca_config {
    address = "{{ vault_addr }}"
{% raw -%}
{{- with secret "/auth/token/create/consul-connect-server" "no_default_policy=false" }}
    token = "{{ .Auth.ClientToken -}}"
{{ end }}
{% endraw %}
    root_pki_path = "hetzner_bootstrap/"
    intermediate_pki_path = "consul_connect/"
    leaf_cert_ttl = "{{ leaf_cert_ttl }}"
    rotation_period = "336h"
    intermediate_cert_ttl = "{{ intermediate_cert_ttl }}"
    private_key_type = "rsa"
    private_key_bits = 2048
  }
}

{% if auto_config is true %}
auto_config {
  authorization {
    enabled = true
    static {
      oidc_discovery_url = "{{ vault_addr }}/v1/identity/oidc"
      bound_issuer = "{{ vault_addr }}/v1/identity/oidc"
      bound_audiences = ["consul-cluster-dc1"]
      claim_mappings = {
        "/consul/hostname" = "node_name"
      }
      claim_assertions = [
        "value.node_name == \"${node}\""
      ]
    }
  }
}
{% endif %}
